#declare o_landscape_mesh = object {
    #if (g_lod_detailmesh > 0)
        #include "ss_terrain.inc"     
    #else
        #include "ss_terrain_lo.inc"     
    #end
}

#macro macro_Generate_Terrain(p_radius_major, p_radius_minor)
    #local l_landscape_depth = p_radius_major + p_radius_minor * 0.5;
    #local l_scalex = l_landscape_depth;
    #local l_scaley = l_landscape_depth;
    #local l_scalez = p_radius_minor * 3.75;
            
    object {
        union {
            object {
                o_landscape_mesh
                #local l_p_smap = macro_p_Landscape_Terrain_Slopemap(90+45/2)
                #local l_n_smap = macro_n_Landscape_Terrain_Slopemap(90+45/2)
                macro_t_Landscape_Terrain(l_p_smap, l_n_smap, 1/l_scalez)
                scale <1, 1, -1>
                translate <0, 0, 1>
                rotate <0, 0, 90>
            }
            object {
                o_landscape_mesh
                #local l_p_smap = macro_p_Landscape_Terrain_Slopemap(45+45/2)
                #local l_n_smap = macro_n_Landscape_Terrain_Slopemap(45+45/2)
                macro_t_Landscape_Terrain(l_p_smap, l_n_smap, 1/l_scalez)
                scale <1, -1, -1>
                translate <0, 0, 1>
                rotate <0, 0, 90>
            }
            object {
                o_landscape_mesh
                #local l_p_smap = macro_p_Landscape_Terrain_Slopemap(45/2)
                #local l_n_smap = macro_n_Landscape_Terrain_Slopemap(45/2)
                macro_t_Landscape_Terrain(l_p_smap, l_n_smap, 1/l_scalez)
            }
            object {
                o_landscape_mesh
                #local l_p_smap = macro_p_Landscape_Terrain_Slopemap(45/2-45)
                #local l_n_smap = macro_n_Landscape_Terrain_Slopemap(45/2-45)
                macro_t_Landscape_Terrain(l_p_smap, l_n_smap, 1/l_scalez)
                scale <1, -1, 1>
                //translate <0, 0, 1>
                rotate <0, 0, 00>
            }
        }
            
        translate <0, 0, -0.5>

            
        scale <l_scalex, l_scaley, l_scalez>
        rotate <0, 90, 0>
        rotate <180, 0, 0>
    }
#end

#macro macro_Generate_Landscape(p_radius_major, p_radius_minor, p_depth)
    macro_Generate_Terrain(p_radius_major, p_radius_minor)

#end

#macro macro_Generate_River(p_radius_major, p_radius_minor, p_depth)
    #local l_floor_depth = p_radius_major + p_depth;
    #local l_wall_offset = p_radius_minor * 1.75 * 1.05;
    #local l_landscape_depth = p_radius_major + p_radius_minor * 0.5;

    #if (g_lod_river > 0)
        difference {
            cylinder {
                <l_wall_offset, 0, 0>,
                <-l_wall_offset, 0, 0>,
                l_landscape_depth * 1.01
                open
                hollow
                material {
                    m_Landscape_Water
                }
            }
            cylinder {
                <l_wall_offset * 1.01, 0, 0>,
                <-l_wall_offset * 1.01, 0, 0>,
                l_landscape_depth * 0.990
                open
                hollow
                material {
                    m_Landscape_Water
                }
            }
            no_reflection
        }
        //
        // Optimise by having the expensive media not appear in reflections,
        // but substitute it with a solid color instead.
        //
        cylinder {
            <l_wall_offset * 1.01001, 0, 0>,
            <-l_wall_offset * 1.01001, 0, 0>,
            l_landscape_depth * 0.9901
            open
            hollow
            no_image
            no_shadow
            inverse
            texture {
                t_Landscape_Water_Solid
            }
        }
    #end

#end
