////////////////////////////////////////////////////////////////////////////////
//
// Textures
//
////////////////////////////////////////////////////////////////////////////////


#default {
    texture {
        pigment {
            color <1,1,1>
        }
        finish {
            diffuse 1.0
            ambient 0
        }
    }
}

#declare t_Transparent = texture {
    pigment {
        color rgbt <1, 1, 1, 1>
    }
}

#declare t_default = texture {
    pigment {
        color <0.8, 0.8, 0.8>
    }
    finish {
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_default_red = texture {
    pigment {
        color <0.8, 0.2, 0.2>
    }
    finish {
        ambient 0.1
        diffuse 0.9
    }
}


#declare t_Conduit_1 = texture {
    pigment {
        color <0.5, 0.5, 0.5>
    }
    finish {
        specular 0.6
        roughness 0.1
    }
    normal {
        bozo
        scale 0.003
    }            
}

#declare t_Shell_Pane_Strut = texture {
    pigment {
        color <0,0,0>
    }
    finish {
        specular 0.6
        roughness 0.1
    }
    normal {
        bozo
        scale 0.003
    }            
}

#declare t_Shell_Pane_Glass = texture {
    pigment {
        #if (g_lod_transparency > 0)
            color <1, 1, 1, 0.8>
        #else
            color <0.5, 0.5, 0.5>
        #end
    }
    
    finish {
        ambient 0
        diffuse 0
        reflection {
            0.05, 0.5
            falloff 3
        }
        conserve_energy
    }
}

#declare t_Shell_Obsidian = texture {
    pigment {
        color <0.5, 0.5, 0.5>
    }
    
    finish {
        ambient 0
        diffuse 0
        reflection {
            0.05, 0.5
            falloff 3
        }
    }
}

#declare t_Shell_Pane_Glass_Null = texture {
    pigment {
        #if (g_lod_transparency > 0)
            color <1, 1, 1, 1>
        #else
            color <0.5, 0.5, 0.5>
        #end
    }
    
    finish {
        ambient 0
        diffuse 0
    }
}

#declare t_Structure_Pipe = texture {
    pigment {
        color <0.2, 0.2, 0.2>
    }
    normal {
        bozo
        scale 0.001
    }
    finish {
        specular 0.6
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_Shell_Base = texture {
    pigment {
        color <0.2, 0.2, 0.2>
    }
    normal {
        bozo
        scale 0.01
    }
    finish {
        specular 0.6
        ambient 0.1
        diffuse 0.9
    }
}

#declare p_Landscape_Terrain_Grass_A = pigment {
    image_map {
        #if (g_lod_detailtextures > 0)
            png "textures/t_grass_512x512.png"
            interpolate 2
        #else
            png "textures_lo/t_grass_512x512.png"
        #end
    }
    scale <1, 100, 1> * 0.01
    warp {
        cylindrical
    }
}

#declare p_Landscape_Terrain_Grass_B = pigment {
    image_map {
        #if (g_lod_detailtextures > 0)
            png "textures/t_patchgrass_1600x1200.png"
            interpolate 2
        #else
            png "textures_lo/t_patchgrass_1600x1200.png"
        #end
    }
    scale 3
    scale <1, 100, 1> * 0.01
    warp {
        cylindrical
    }
}

#declare p_Landscape_Terrain_Rocks = pigment {
    bozo
    pigment_map {
         [0.000 color rgbt <0.290, 0.157, 0.157, 0.000>]
         [0.118 color rgbt <0.322, 0.318, 0.259, 0.000>]
         [0.994 color rgbt <0.569, 0.427, 0.208, 0.000>]
    }
    scale -<0.002, 0.2, 0.001> * 2
    warp {
        cylindrical
    }
}   

#declare p_Landscape_Terrain_Grass = pigment {
    bozo
    pigment_map {
        [0 p_Landscape_Terrain_Grass_A]
        [0.25 p_Landscape_Terrain_Grass_A]
        [0.75 p_Landscape_Terrain_Grass_B]
        [1 p_Landscape_Terrain_Grass_B]
    }
    scale 0.5
}

#declare p_Landscape_Terrain_Sand = pigment {
    image_map {
        #if (g_lod_detailtextures > 0)
            png "textures/t_sand_1024x1024.png"
            interpolate 2
        #else
            png "textures_lo/t_sand_1024x1024.png"
        #end
    }
    scale <1, 100, 1> * 0.01
    warp {
        cylindrical
    }
}

#macro macro_p_Landscape_Terrain_Slopemap(p_angle)
    pigment {
        slope {
            vaxis_rotate(z, x, p_angle)
        }
        pigment_map {
            [0.000 p_Landscape_Terrain_Grass]
            [0.100 p_Landscape_Terrain_Grass]
            [0.120 p_Landscape_Terrain_Sand]
            [0.190 p_Landscape_Terrain_Sand]
            [0.210 p_Landscape_Terrain_Rocks]
            [1.000 p_Landscape_Terrain_Rocks]
        }
    }
#end

#macro macro_n_Landscape_Terrain_Slopemap(p_angle)
    normal {
        slope {
            vaxis_rotate(z, x, p_angle)
        }
        normal_map {
            [0.000 bumps 0]
            [0.100 bumps 0]
            [0.120 bumps 0]
            [0.190 bumps 0]
            [0.210 crackle bump_size 0.2 scale -<0.0002, 0.02, 0.0001> warp { cylindrical }]
            [1.000 crackle bump_size 0.2 scale -<0.0002, 0.02, 0.0001> warp { cylindrical }]
        }
    }
#end

#macro macro_t_Landscape_Terrain(p_p_slopetexture, p_n_slopenormal, p_zscale)
    texture {
        pigment {
            cylindrical
            pigment_map {
                [0.000 p_Landscape_Terrain_Sand]
                [0.010 p_Landscape_Terrain_Sand]
                [0.025 p_p_slopetexture]
                [0.050 p_p_slopetexture]
                [0.055 p_Landscape_Terrain_Grass]
                [1.000 p_Landscape_Terrain_Grass]
            }
            rotate <90, 0, 0>
            scale <1, 1, p_zscale>
        }
        normal {
            cylindrical
            normal_map {
                [0.000 bumps 0]
                [0.010 bumps 0]
                [0.025 p_n_slopenormal]
                [0.050 p_n_slopenormal]
                [0.055 bumps 0]
                [1.000 bumps 0]
            }
            rotate <90, 0, 0>
            scale <1, 1, p_zscale>
        }
    }
#end


#declare m_Shell_Pane_Glass = material {
    texture {
        pigment {
            color <1, 1, 1, 0.8>
        }
        finish {
            ambient 0
            diffuse 0
            reflection {
                0.5
                fresnel on
            }
            conserve_energy
        }
    }
    interior {
        ior 1.5
    }
    
}

#declare t_Traintracks_Main = texture {
    pigment {
        #if (g_lod_transparency > 0)
            //color <0, 0, 1>
            color <0.5, 0.5, 0.5, 0.9>
        #else
            color <0.5, 0.5, 0.5>
        #end
    }
    finish {
        ambient 0
        diffuse 0.5
        specular 0.4
        roughness 0.1
        reflection {
            0.5
            fresnel on
        }
        conserve_energy
    }
}

#declare t_Traintracks_Logo = texture {
    pigment {
        #if (g_lod_transparency > 0)
            color <1, 1, 1, 0.5>
        #else
            color <0.5, 0.5, 0.5>
        #end
    }
    finish {
        ambient 0
        diffuse 0.5
        specular 0.7
        roughness 0.2
        reflection {
            0.3
            fresnel on
        }
        conserve_energy
    }
}

#declare t_Traintracks = texture {
    pigment_pattern {
        image_map {
            png "textures/m_logo_768x768.png"
            interpolate 2
            once
        }
        translate <-0.5, -0.5, 0>
        rotate <0, 0, 90>
        scale <0.15, 0.3, 1>
        translate <0.5, 0.5, 0>
        warp {
            cylindrical
            orientation z
        }

    }
    texture_map {
        [0 t_Traintracks_Main]
        [1 t_Traintracks_Logo]
    }
}

#declare t_Girder = texture {
    pigment {
        bozo
        color_map {
            [0.0 rgb <0.9, 0.9, 0.9>]
            [0.5 rgb <0.9, 0.9, 0.9>]
            [0.5 rgb <0.8, 0.8, 0.8>]
            [1.0 rgb <0.8, 0.8, 0.8>]
        }
        warp {
            turbulence 0.1
        }
        scale <0.002, 0.01, 0.01>
    }
    finish {
        diffuse 0.9
        ambient 0.1
        phong 1
    }
}

#declare t_Leaf_1_Actual = texture {
    uv_mapping pigment {
        image_map {
            png "textures/t_leaf1_648x486.png"
        interpolate 2
        }
    }
    finish {
        specular 0.2
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_Leaf_2_Actual = texture {
    uv_mapping pigment {
        image_map {
            png "textures/t_leaf2_648x486.png"
        interpolate 2
        }
    }
    finish {
        specular 0.2
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_Leaf_3_Actual = texture {
    uv_mapping pigment {
        image_map {
            png "textures/t_leaf3_648x486.png"
        interpolate 2
        }
    }
    finish {
        specular 0.2
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_Leaf_4_Actual = texture {
    uv_mapping pigment {
        image_map {
            png "textures/t_leaf4_648x486.png"
        interpolate 2
        }
    }
    finish {
        specular 0.2
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_Leaf_1 = texture {
    uv_mapping pigment_pattern {
        image_map {
            png "textures/m_leaf1_648x486.png"
            interpolate 2
        }
    } 
    texture_map {
        [0 t_Transparent]
        [1 t_Leaf_1_Actual]
    }
}

#declare t_Leaf_2 = texture {
    uv_mapping pigment_pattern {
        image_map {
            png "textures/m_leaf1_648x486.png"
            interpolate 2
        }
    } 
    texture_map {
        [0 t_Transparent]
        [1 t_Leaf_2_Actual]
    }
}

#declare t_Leaf_3 = texture {
    uv_mapping pigment_pattern {
        image_map {
            png "textures/m_leaf1_648x486.png"
            interpolate 2
        }
    } 
    texture_map {
        [0 t_Transparent]
        [1 t_Leaf_3_Actual]
    }
}

#declare t_Leaf_4 = texture {
    uv_mapping pigment_pattern {
        image_map {
            png "textures/m_leaf1_648x486.png"
            interpolate 2
        }
    } 
    texture_map {
        [0 t_Transparent]
        [1 t_Leaf_4_Actual]
    }
}

#declare t_Leaf_FILL = texture {
    pigment {
        color <0.5, 0.5, 1>
    }
    finish {
        specular 0.6
        ambient 0.1
        diffuse 0.9
    }
}

#declare t_Leaf_Array = array[4];
#declare t_Leaf_Array[0] = t_Leaf_1;
#declare t_Leaf_Array[1] = t_Leaf_2;
#declare t_Leaf_Array[2] = t_Leaf_3;
#declare t_Leaf_Array[3] = t_Leaf_4;

#declare t_Tree_Trunk = texture {
    pigment {
        color <0.722, 0.427, 0.165>
    }
    normal {
        crackle
        scale 0.01
    }
    finish {
        ambient 0.1
        diffuse 0.9
    }
}


#declare m_Landscape_Water = material {
    texture {
        pigment {
            color rgbt <0.0, 0.0, 0.0, 1>
        }
        finish {
            ambient 0.2
            diffuse 0.8

            reflection {
                0.0, 1.0
            }

            specular 0.4
            roughness 0.003
        }
        normal {
            bozo
            scale 0.1
        }
    }
    #if (g_lod_river_media > 0)
        interior {
            media {
                absorption 5
                scattering {
                    2
                    <0.5, 0.25, 0.1> * 50
                }
            }
        }
    #end
}

#declare t_Landscape_Water_Solid = texture {
    pigment {
        color <0.6, 0.45, 0.27>
    }
    finish {
        ambient 0.2
        diffuse 0.8

        reflection {
            0.0, 1.0
        }

        specular 0.4
        roughness 0.003
    }
    normal {
        bozo
        scale 0.1
    }
}

#declare m_Shell_Fog = material {
    texture {
        pigment {
            color rgbt <0.0, 0.0, 0.0, 1>
        }
        finish {
            ambient 0.0
            diffuse 0.0
            specular 0.0
        }
    }
    interior {
        media {
            absorption 0.055
            emission <0.52, 0.41, 0.41> * 0.045
        }
    }
}

#declare t_Engine_Radiant = texture {
    pigment {
        rgb <1, 1, 1.5>
    }
    finish {
        ambient 1
        diffuse 0
    }
}

#macro macro_t_Generator_Hub(p_radius)
    texture {
        pigment {               
            image_map {
                png "textures/t_generator_1024x128.png"
                interpolate 2
            }
            scale <1, 0.1, 1>
            rotate <0, 0, 90>
            warp {
                toroidal
                orientation z
                major_radius p_radius
            }            
        }
        finish {
            ambient 1
            diffuse 0
        }
    }
#end

#declare m_Engine_Energy = material {
    texture {
        pigment {
            rgbt <1, 1, 1, 1>
        }
        finish {
            ambient 0
            diffuse 0
        }
    }
    
    interior {
        media {
            emission 1
            density {
                crackle
                color_map {
                    [0.01 rgb <1, 1, 1>]
                    [0.05 rgb <0, 0, 1>]
                    [0.1 rgb <0, 0, 0>]
                    [1.0 rgb <0, 0, 0>]
                }
                scale 0.2
            }
            density {
                spherical
                color_map {
                    [0.0 rgb <0, 0, 0>]
                    [0.2 rgb <1, 1, 1>]
                    [1.0 rgb <1, 1, 1>]
                }
            }
        }
        media {
            emission 1
            density {
                spherical
                color_map {
                    [0.0 rgb <0, 0, 0>]
                    [0.2 rgb <0, 0, 0>]
                    [1.0 rgb <1, 1, 1>]
                }
            }
        }
    }
}

#declare p_Star_Map = pigment {
    image_map {
        #if (g_lod_detailtextures > 0)
            png "textures/t_starfield_8192x8192.png"
            interpolate 2
        #else
            png "textures_lo/t_starfield_8192x8192.png"
        #end
    }
    scale 0.1
    warp {
        spherical
    }
}

#declare g_building_texture_seed = seed(0);
#macro macro_Calculate_Building_Textures(p_output_array, p_layers, p_window_pct)
    //
    // Pick a main color to use.
    //
    #local l_color_array = array[10];
    #local l_color_array[0] = <0.196, 0.196, 0.384>;
    #local l_color_array[1] = <0.259, 0.259, 0.322>;
    #local l_color_array[2] = <0.259, 0.310, 0.322>;
    #local l_color_array[3] = <0.259, 0.322, 0.278>;
    #local l_color_array[4] = <0.322, 0.318, 0.259>;
    #local l_color_array[5] = <0.322, 0.259, 0.259>;
    #local l_color_array[6] = <0.271, 0.259, 0.322>;
    #local l_color_array[7] = <0.165, 0.165, 0.165>;
    #local l_color_array[8] = <0.290, 0.290, 0.290>;
    #local l_color_array[9] = <0.302, 0.290, 0.208>;
    
    #local l_main_color =
l_color_array[floor(rand(g_building_texture_seed)*0.9999999*dimension_size(l_color_array,1))];
        //Rand_Array_Item(l_color_array, g_building_texture_seed);
        // Why does it not work when I use Rand_Array_Item?!??!?

    //
    // Pick a window tint color
    //
    #local l_tint_color =
l_color_array[floor(rand(g_building_texture_seed)*0.9999999*dimension_size(l_color_array,1))];
        //Rand_Array_Item(l_color_array, g_building_texture_seed);

    //
    // Build the plain texture
    //
    #local l_t_plain = texture {
        pigment {
            color l_main_color
        }
        normal {
            bozo
            scale <0.03, 0.003, 0.03>
            bump_size 1.5
        }            
        finish {
            diffuse 0.9
            ambient 0.1
        }
    }

    //
    // Build the base window texture
    //
    #local l_reflect = m_RandRangeS(0.25,0.5,g_building_texture_seed);
    #local l_t_window_base = texture {
        pigment {
            color l_tint_color * 0.25
        }
        normal {
            bozo
            scale <0.1, 20, 0.1>
            bump_size 0.001
        }            
        finish {
            reflection l_reflect
            diffuse 0.9
            ambient 0.1
        }
    }

    //
    // Build the window texture
    //
    #local l_reflect = m_RandRangeS(0.25,0.5,g_building_texture_seed);
    #local l_t_window = texture {
        brick
        texture {
            l_t_plain
            scale <1, 1/50, 1>
        }
        texture {
            l_t_window_base
        }
        brick_size 0.15
        mortar 0.02
        translate <0, -0.5, 0>
        scale <1, 50, 1>
    }

    //
    // Build the complete texture
    //
    #local l_i = 0;
    #local l_gradient_increment = 1 / p_layers;
    #local l_window_increment = l_gradient_increment * p_window_pct / 100;
    #local l_t_main = texture {
        gradient y
        texture_map {
            #while (l_i < (p_layers - 1))
                #local l_level_offset = l_gradient_increment * l_i;
                #local l_window_offset = l_level_offset + l_window_increment;
                [l_level_offset l_t_plain]
                [(l_level_offset + 0.0001) l_t_window]
                [(l_window_offset - 0.0001) l_t_window]
                [l_window_offset l_t_plain]
                #local l_i = l_i + 1;
            #end
        }
    }

    #declare p_output_array[0] = l_t_main;
    #declare p_output_array[1] = l_t_plain;
    #declare p_output_array[2] = l_t_window_base;
#end

#declare g_cable_texture_seed = seed(0);
#macro macro_t_Cable(p_color)
    #local l_t_plain_color = texture {
        pigment {
            color p_color
        }
        finish {
            diffuse 0.9
            ambient 0.1
            phong 0.5
        }
    }


    #local l_t_decay_color = texture {
        pigment {
            color p_color * 0.2
        }
        finish {
            diffuse 0.9
            ambient 0.1
            phong 0.5
        }
    }

    #local l_t_wire_color = texture {
        pigment {
            color <0.792, 0.565, 0.165>
        }
        normal {
            dents
            scale 0.5
            bump_size 0.5
        }
        finish {
            diffuse 0.9
            ambient 0.1
            specular 0.3
            reflection 0.6
        }
    }

    // If this dummy assignment isn't here, the parser thinks the next texture
    // is layered on the previous... which is NOT what I want...
    #local l_x = 0;

    texture {
        bozo
        texture_map {
            [0.000 l_t_plain_color]
            [0.700 l_t_plain_color]
            [0.750 l_t_decay_color]
            [0.750 l_t_wire_color]
            [1.000 l_t_wire_color]
        }
        scale 0.001
    }

#end

#declare t_Cables = array[4];
#declare t_Cables[0] = macro_t_Cable(<0.412, 0.306, 0.153>);    // brown
#declare t_Cables[1] = macro_t_Cable(<0.482, 0.082, 0.082>);    // red
#declare t_Cables[2] = macro_t_Cable(<0.173, 0.275, 0.157>);    // green
#declare t_Cables[3] = macro_t_Cable(<0.839, 0.839, 0.839>);    // white

#declare t_Trainstop_Base = texture {
    pigment {
        bozo
        pigment_map {
            [0.000 color rgb <0.761, 0.753, 0.800>]
            [0.450 color rgb <0.620, 0.604, 0.682>]
            [1.000 color rgb <0.765, 0.757, 0.804>]
        }
        scale 0.05
    }
    normal {
        bozo
        scale 0.004
        bump_size 0.5
    }            
    finish {
        diffuse 0.9
        ambient 0.1
    }
}

#declare t_Trainstop_Head_Sphere = texture {
    pigment {
        pigment_pattern {
            image_map {
                png "textures/m_trainhull_256x256.png"
                interpolate 2
            }
            warp {
                spherical
            }
        }
        pigment_map {
            [0 color rgb <0.196, 0.196, 0.384>]
            [1 color rgb <1, 1, 1>]
        }
    }
    normal {
        bump_map {
            png "textures/m_trainhull_256x256.png"
            interpolate 2
        }
        warp {
            spherical
        }
    }            
    finish {
        reflection 0.25
        diffuse 0.9
        ambient 0.1
    }
}

#declare t_Trainstop_Head_Tube = texture {
    pigment {
        gradient y
        pigment_map {
            [0.000 color rgbt <0.196, 0.196, 0.384, 1.000>]
            [0.001 color rgbt <0.196, 0.196, 0.384, 0.000>]
            [0.824 color rgbt <0.855, 0.855, 0.925, 0.000>]
            [0.850 color rgbt <0.667, 0.659, 0.729, 1.000>]
            [0.918 color rgbt <0.655, 0.647, 0.722, 1.000>]
            [0.934 color rgbt <1.000, 0.000, 0.000, 0.000>]
            [0.914 color rgbt <1.000, 0.000, 0.000, 0.000>]
            [1.000 color rgbt <0.196, 0.196, 0.384, 1.000>]
        }
    }
    finish {
        diffuse 0.9
        ambient 0.1
    }
}

#declare m_Carriage_Smoke = material {
    texture {
        pigment {
            rgbt <1, 1, 1, 1>
        }
    }
    interior {
        media {
            absorption 25
            density {
                bozo
                color_map {
                    [0.0 rgb <1, 1, 1>]
                    [1.0 rgb <0, 0, 0>]
                }
                scale 0.2
            }
            density {
                spherical
                color_map {
                    [0.0 rgb <0, 0, 0>]
                    [0.3 rgb <1, 1, 1>]
                }
            }
        }
        media {
            emission 40
            density {
                bozo
                color_map {
                    [0.0 rgb <1, 1, 1>]
                    [1.0 rgb <0, 0, 0>]
                }
                scale 0.2
            }
            density {
                spherical
                color_map {
                    [0.0 rgb <0, 0, 0>]
                    [0.4 rgb <1, 1, 1>]
                    [0.5 rgb <1, 0.5, 0> * 4]
                    [1.0 rgb <1, 1, 0> * 10]
                }
                scale 5
                warp {
                    turbulence 1
                }
                scale 0.2
            }
        }
    }
}


#declare t_Carriage_Hull = texture {
    pigment {
        image_map {
            png "textures/t_svhull_1024x1024.png"
            interpolate 2
        }
        warp {
            cylindrical
        }
        scale <1, 20, 1>
    }
    normal {
        bump_map {
            png "textures/n_svhull_1024x1024.png"
            bump_size 0.5
            interpolate 2
        }
        warp {
            cylindrical
        }
        scale <1, 20, 1>
    }
    finish {
        specular 0.3
        diffuse 0.9
        ambient 0.1
    }
}


#declare t_Carriage_L1 = texture {
    t_Carriage_Hull
    translate <0, 5, 0>
}

#declare t_Carriage_L2 = texture {
    pigment {
        color <1, 0.75, 0.5>
    }
    finish {
        reflection 0.5
        diffuse 0.6
        ambient 0.4
    }
}

#declare t_Carriage_L3 = texture {
    pigment {
        color <1, 0.5, 0>
    }
    finish {
        reflection 0.5
        diffuse 0.6
        ambient 0.4
    }
}

#declare t_Carriage_L4 = texture {
    t_Carriage_Hull
}

#declare t_Carriage_L5 = texture {
    pigment {
        color <0.75, 0.75, 0.75>
    }
    finish {
        specular 0.5
        diffuse 0.9
        ambient 0.1
    }
}
